> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://docs.coperniq.io/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://docs.coperniq.io/_mcp/server.

# Get Form

GET https://api.coperniq.io/v1/forms/{form_id}

Retrieve a specific form by ID with detailed layout information

Reference: https://docs.coperniq.io/api-reference/forms/get-form

## Authentication

- `x-api-key` header (required) — API Key authentication via header

## Request

### Path parameters

- `form_id` (integer, required) — Form identifier

## Response

### 200

Form details

- `id` (integer, optional) — Form identifier
- `name` (string, optional) — Form name
- `description` (string, optional, nullable) — Form description
- `templateId` (integer, optional, nullable) — Template ID
- `updatedAt` (string, optional) — Last update timestamp
- `status` (enum, optional) — Form status
  - Allowed values: `UNASSIGNED`, `ASSIGNED`, `REVIEW`, `CHANGES_REQUESTED`, `COMPLETED`, `CANCELLED`
- `isCompleted` (boolean, optional) — Whether the form is completed
- `completedAt` (string, optional, nullable) — Completion timestamp
- `createdAt` (string, optional) — Creation timestamp
- `createdByUser` (UserSummary, optional) — Minimal user representation used in responses
- `assignee` (UserSummary, optional) — Minimal user representation used in responses
- `dueDate` (string, optional, nullable) — Due date
- `projectId` (integer, optional) — Associated project ID
- `phaseId` (integer, optional, nullable) — Phase template ID (if available)
- `phaseName` (string, optional, nullable) — Phase template name (if available)
- `formLayouts` (list of FormLayoutGroup, optional) — Form layout sections
- `collaborators` (list of UserSummary, optional) — Additional users collaborating on the form

## Errors

### 401 Unauthorized Error

Authentication failed

- `message` (string, optional)
- `code` (enum, optional)
  - Allowed values: `NOT_FOUND`

### 404 Not Found Error

Resource not found

- `message` (string, optional)
- `code` (enum, optional)
  - Allowed values: `NOT_FOUND`

## Types

### UserSummary

Minimal user representation used in responses

- `id` (integer, optional)
- `firstName` (string, optional, nullable)
- `lastName` (string, optional, nullable)
- `email` (string, optional, nullable)
- `avatarUrl` (string, optional, nullable)

### FormLayoutGroup

- `id` (FormLayoutGroupId, optional) — Group identifier ("default" for ungrouped properties)
- `type` (enum, optional)
  - Allowed values: `GROUP`
- `name` (string, optional) — Group name
- `properties` (list of FormField, optional)
- `fields` (list of FormField, optional) — Alias for properties. Both keys are returned in responses for backwards compatibility.

### FormLayoutGroupId

Group identifier ("default" for ungrouped properties)

- integer
- string

### FormField

- `id` (integer, optional) — Child form layout identifier
- `columnId` (integer, optional) — Column identifier on the form layout
- `name` (string, optional) — Field label
- `type` (string, optional) — Field type
- `value` (FormFieldValue, optional, nullable) — Normalized field value

### FormFieldValue

Normalized field value

- string
- double
- User: UserSummary
- Files: list of FormFile
- list of string

### FormFile

- `id` (integer, optional)
- `name` (string, optional)
- `downloadUrl` (string, optional)
- `metaData` (map from string to any, optional)

## Examples

**Response**

```json
{
  "id": 1,
  "name": "string",
  "description": "string",
  "templateId": 1,
  "updatedAt": "2024-01-15T09:30:00Z",
  "status": "UNASSIGNED",
  "isCompleted": true,
  "completedAt": "2024-01-15T09:30:00Z",
  "createdAt": "2024-01-15T09:30:00Z",
  "createdByUser": {
    "id": 1,
    "firstName": "string",
    "lastName": "string",
    "email": "string",
    "avatarUrl": "string"
  },
  "assignee": {
    "id": 1,
    "firstName": "string",
    "lastName": "string",
    "email": "string",
    "avatarUrl": "string"
  },
  "dueDate": "2024-01-15T09:30:00Z",
  "projectId": 1,
  "phaseId": 1,
  "phaseName": "string",
  "formLayouts": [
    {
      "id": 1,
      "type": "GROUP",
      "name": "string",
      "properties": [
        {
          "id": 1,
          "columnId": 1,
          "name": "string",
          "type": "string",
          "value": "string"
        }
      ],
      "fields": [
        {
          "id": 1,
          "columnId": 1,
          "name": "string",
          "type": "string",
          "value": "string"
        }
      ]
    }
  ],
  "collaborators": [
    {
      "id": 1,
      "firstName": "string",
      "lastName": "string",
      "email": "string",
      "avatarUrl": "string"
    }
  ]
}
```

**SDK Code**

```python
import requests

url = "https://api.coperniq.io/v1/forms/1"

headers = {"x-api-key": "<apiKey>"}

response = requests.get(url, headers=headers)

print(response.json())
```

```javascript
const url = 'https://api.coperniq.io/v1/forms/1';
const options = {method: 'GET', headers: {'x-api-key': '<apiKey>'}};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go
package main

import (
	"fmt"
	"net/http"
	"io"
)

func main() {

	url := "https://api.coperniq.io/v1/forms/1"

	req, _ := http.NewRequest("GET", url, nil)

	req.Header.Add("x-api-key", "<apiKey>")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby
require 'uri'
require 'net/http'

url = URI("https://api.coperniq.io/v1/forms/1")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Get.new(url)
request["x-api-key"] = '<apiKey>'

response = http.request(request)
puts response.read_body
```

```java
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.get("https://api.coperniq.io/v1/forms/1")
  .header("x-api-key", "<apiKey>")
  .asString();
```

```php
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('GET', 'https://api.coperniq.io/v1/forms/1', [
  'headers' => [
    'x-api-key' => '<apiKey>',
  ],
]);

echo $response->getBody();
```

```csharp
using RestSharp;

var client = new RestClient("https://api.coperniq.io/v1/forms/1");
var request = new RestRequest(Method.GET);
request.AddHeader("x-api-key", "<apiKey>");
IRestResponse response = client.Execute(request);
```

```swift
import Foundation

let headers = ["x-api-key": "<apiKey>"]

let request = NSMutableURLRequest(url: NSURL(string: "https://api.coperniq.io/v1/forms/1")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "GET"
request.allHTTPHeaderFields = headers

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```